#include <stdio.h>
#include <string.h>

#define ARRAY_SIZE 100
#define MAX_STRINGS 100

/* Read and store multiple strings within one array of chars. 
 * Dynamically change scanf format string each time according to
 * the remaining array length. Maintain another array of pointers
 * with each position pointing to the beginning of a string. 
 * Keep reading strings till there is no more room in array, or
 * the user enters "stop" as a string */

int main(int argc, char *argv[]) {
	char array[ARRAY_SIZE];		/* This is where strings are stored */
	char *strings[MAX_STRINGS] = {NULL}; /* Each position in this array will
										  * point to the beginning of a string
										  * in array */
	char *string_start;
	char format_str[20];
	int string_length, remaining_length = ARRAY_SIZE-1;
	unsigned int strings_read = 0;
	int i;
	
	printf("Enter strings:\n");
	
	/* string_start is the beginning of the empty part of the array */ 
	string_start = array;
	
	/* Make format_str and do a scanf for reading the 1st string */
	sprintf(format_str,"%%%ds", remaining_length);
	scanf(format_str, string_start);
	
	/* Stop if the string read was "stop" */
	while (strcmp(string_start, "stop") != 0) {
		string_length = strlen(string_start);
		remaining_length = remaining_length - string_length - 1;
		strings[strings_read] = string_start;
		strings_read++;
		
		if (remaining_length <= 0) 
			break;
					
		/* Create the format_str for the next scanf, according to the 
		 * remaining (free) length of array */
		sprintf(format_str,"%%%ds", remaining_length);
		/* Make string start point again to the beginning of the free part
		 * of the array. Don't forget to account for the '\0' terminating
		 * the string just read */
		string_start = string_start + string_length + 1;
		/* Now read the string for the next iteration */
		scanf(format_str, string_start);
	}
	
	/* Print the strings stored in the array, using the pointers to their
	 * beginnings stored in strings array */
	printf("Printing strings:\n");
	for (i = 0; i < strings_read; i++)
		printf("%s\n", strings[i]);

	return(0);
}
