#include <stdio.h>
#include <string.h>

#define LENGTH 50

int main(int argc, char *argv[]) {
	/* Always make sure that there is enough room in 
	 * dest for whatever you want to copy there. The 
	 * "strange" initialization with 'a' is going to 
	 * help us identify any problems with proper string 
	 * termination ('\0') */
	char dest[10*LENGTH];
	char src[LENGTH] = "This is a test";
	

	/* This should be an insta-crash. dest does not contain a string!!! If a segfault 
	 * does not occur, it is totally out of luck. Comment the next 2 lines out to 
	 * continue with the rest of the program */
	strcat(dest, src);
	printf("Dest: %s\n", dest);

	/* After this, dest will contain an string) */
	strcpy(dest, "Hello there! ");
	printf("Dest: %s\n", dest);
	/* Alternatively comment the previous and uncomment any of the
	 * following two lines to make dest contain an empty string */
	/* strcpy(dest, "");*/
	/* dest[0] = '\0'; */
	
	/* Dest will be \0 terminated (contrary to what would happen with
	 * an strncpy)! */
	/* Observe that the string in src is concatenated after the existing
	 * string in dest. Always make sure that there is enough room in dest
	 * for the concatenation */
	strncat(dest, src, 6);
	printf("Dest: %s\n", dest);
		
	/* Concatenate more than the length of the string in src. No problem, 
	 * it will just copy src and continue writing \0 till 20 
	 * characters are written in dest */
	strncat(dest, src, 20);
	printf("Dest: %s\n", dest);
	
	return 0;
}
 
