#include <stdio.h>
#include <string.h>

#define LENGTH 50

int main(int argc, char *argv[]) {
	/* Always make sure that there is enough room in 
	 * dest for whatever you want to copy there. The 
	 * "strange" initialization with 'a' is going to 
	 * help us identify any problems with proper string 
	 * termination ('\0') */
	char dest[LENGTH] = {'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a',
						 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 
						 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a'};
						 
	char src[LENGTH] = "This is a test";
	
	/* Dest will not be \0 terminated!!! As a result, 
	 * the printf will continue printing the aaaa...
	 * we used to initialize dest. It will continue to 
	 * read after the end of dest, till segfault happens
	 * or till we happen to read a \0 */ 
	strncpy(dest, src, 6);
	printf("Dest: %s\n", dest);
	
	/* A proper way to do this would be the following */
	strncpy(dest, src, 6);
	dest[6] = '\0';
	printf("Dest: %s\n", dest);
	

	/* Copy more than the length of the string in src. No problem, 
	 * it will just copy src and continue writing \0 till 20 
	 * characters are written in dest */
	strncpy(dest, src, 20);
	printf("Dest: %s\n", dest);
	
	
	return 0;
}
 
